# Generated by Django 5.1.3 on 2025-05-14 16:54

import django.db.models.deletion
import pytigon_lib.schdjangoext.fields
import pytigon_lib.schtools.schjson
from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ("schelements", "0001_initial"),
    ]

    operations = [
        migrations.CreateModel(
            name="DocDef",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "app",
                    models.CharField(
                        db_index=True, max_length=16, verbose_name="Application"
                    ),
                ),
                (
                    "name",
                    models.CharField(db_index=True, max_length=64, verbose_name="Name"),
                ),
                (
                    "description",
                    models.CharField(max_length=64, verbose_name="Description"),
                ),
                (
                    "declaration",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Declaration",
                    ),
                ),
                (
                    "template_src",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Template source",
                    ),
                ),
                (
                    "template",
                    models.TextField(
                        blank=True, editable=False, null=True, verbose_name="Template"
                    ),
                ),
                (
                    "to_html_rec",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Convert fields to html",
                    ),
                ),
                (
                    "save_fun",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Save function",
                    ),
                ),
                (
                    "load_fun",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Load function",
                    ),
                ),
                (
                    "to_str_fun",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Object to str function",
                    ),
                ),
                (
                    "action_template",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Action template",
                    ),
                ),
                (
                    "info_template",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Info template",
                    ),
                ),
                (
                    "on_delete_fun",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Fnction called when deleting an object",
                    ),
                ),
                (
                    "action_fun",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Additional actions",
                    ),
                ),
                (
                    "doc_type",
                    models.CharField(
                        blank=True,
                        max_length=16,
                        null=True,
                        verbose_name="Associated document type",
                    ),
                ),
            ],
            options={
                "verbose_name": "Document definition",
                "verbose_name_plural": "Documents definitions",
                "ordering": ["id"],
                "permissions": [("admin_repdef", "Can administer report definitions")],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
        migrations.CreateModel(
            name="Doc",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "jsondata",
                    models.JSONField(
                        blank=True,
                        decoder=pytigon_lib.schtools.schjson.ComplexDecoder,
                        editable=False,
                        encoder=pytigon_lib.schtools.schjson.ComplexEncoder,
                        null=True,
                        verbose_name="Json data",
                    ),
                ),
                (
                    "order",
                    models.IntegerField(
                        blank=True, null=True, verbose_name="Order number"
                    ),
                ),
                (
                    "doc_def_name",
                    models.CharField(
                        max_length=64, verbose_name="Document definition name"
                    ),
                ),
                (
                    "date",
                    models.DateTimeField(blank=True, null=True, verbose_name="Date"),
                ),
                (
                    "parent",
                    pytigon_lib.schdjangoext.fields.ForeignKey(
                        blank=True,
                        editable=False,
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        to="schdoc.doc",
                        verbose_name="Parent",
                    ),
                ),
                (
                    "parent_doc",
                    pytigon_lib.schdjangoext.fields.ForeignKey(
                        blank=True,
                        editable=False,
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        to="schelements.dochead",
                        verbose_name="Parent document",
                    ),
                ),
            ],
            options={
                "verbose_name": "Document",
                "verbose_name_plural": "Documents",
                "ordering": ["parent_id", "order", "id"],
                "permissions": [("admin_report", "Can administer reports")],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
    ]
