# Generated by Django 5.1.3 on 2025-05-14 16:54

import django.db.models.deletion
import pytigon_lib.schdjangoext.fields
from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ("schelements", "0001_initial"),
        ("schstruct", "0001_initial"),
    ]

    operations = [
        migrations.CreateModel(
            name="LabelType",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=256, verbose_name="Name")),
                (
                    "title",
                    models.CharField(
                        blank=True, max_length=256, null=True, verbose_name="Title"
                    ),
                ),
            ],
            options={
                "verbose_name": "Label type",
                "verbose_name_plural": "Label types",
                "ordering": ["id"],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
        migrations.CreateModel(
            name="Label",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "application",
                    models.CharField(
                        db_index=True,
                        editable=False,
                        max_length=64,
                        verbose_name="Application",
                    ),
                ),
                (
                    "table",
                    models.CharField(
                        db_index=True,
                        default="default",
                        editable=False,
                        max_length=64,
                        verbose_name="Table",
                    ),
                ),
                (
                    "group",
                    models.CharField(
                        blank=True,
                        db_index=True,
                        default="default",
                        editable=False,
                        max_length=64,
                        null=True,
                        verbose_name="Group",
                    ),
                ),
                (
                    "parent_id",
                    models.IntegerField(
                        blank=True,
                        db_index=True,
                        editable=False,
                        null=True,
                        verbose_name="Parent id",
                    ),
                ),
                (
                    "type",
                    pytigon_lib.schdjangoext.fields.ForeignKey(
                        editable=False,
                        on_delete=django.db.models.deletion.CASCADE,
                        to="schlabels.labeltype",
                        verbose_name="Type",
                    ),
                ),
            ],
            options={
                "verbose_name": "Label",
                "verbose_name_plural": "Labels",
                "ordering": ["id"],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
        migrations.CreateModel(
            name="ElementLabel",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "parent",
                    pytigon_lib.schdjangoext.fields.ForeignKey(
                        editable=False,
                        on_delete=django.db.models.deletion.CASCADE,
                        to="schelements.element",
                        verbose_name="Parent",
                    ),
                ),
                (
                    "type",
                    pytigon_lib.schdjangoext.fields.ForeignKey(
                        editable=False,
                        on_delete=django.db.models.deletion.CASCADE,
                        to="schlabels.labeltype",
                        verbose_name="Type",
                    ),
                ),
            ],
            options={
                "verbose_name": "Element label",
                "verbose_name_plural": "Element labels",
                "ordering": ["id"],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
        migrations.CreateModel(
            name="CommonGroupLabel",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "parent",
                    pytigon_lib.schdjangoext.fields.ForeignKey(
                        editable=False,
                        on_delete=django.db.models.deletion.CASCADE,
                        to="schstruct.commongroup",
                        verbose_name="Group",
                    ),
                ),
                (
                    "type",
                    pytigon_lib.schdjangoext.fields.ForeignKey(
                        editable=False,
                        on_delete=django.db.models.deletion.CASCADE,
                        to="schlabels.labeltype",
                        verbose_name="Type",
                    ),
                ),
            ],
            options={
                "verbose_name": "Common group label",
                "verbose_name_plural": "Common groups labels",
                "ordering": ["id"],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
    ]
