# Generated by Django 5.1.3 on 2025-05-14 16:54

import django.contrib.auth.models
import django.db.models.deletion
import pytigon_lib.schdjangoext.fields
import schprofile.models
from django.conf import settings
from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ("auth", "0012_alter_user_first_name_max_length"),
        ("schelements", "0001_initial"),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name="UserProxy",
            fields=[],
            options={
                "verbose_name": "User",
                "verbose_name_plural": "Users",
                "ordering": ["id"],
                "proxy": True,
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
                "indexes": [],
                "constraints": [],
            },
            bases=("auth.user",),
            managers=[
                ("objects", django.contrib.auth.models.UserManager()),
            ],
        ),
        migrations.CreateModel(
            name="Profile",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "user_type",
                    models.CharField(
                        blank=True, max_length=32, null=True, verbose_name="User type"
                    ),
                ),
                (
                    "doc_regs",
                    models.CharField(
                        blank=True,
                        max_length=256,
                        null=True,
                        verbose_name="Allowed document registers",
                    ),
                ),
                (
                    "doc_types",
                    models.CharField(
                        blank=True,
                        max_length=256,
                        null=True,
                        verbose_name="Allowed document types",
                    ),
                ),
                (
                    "accounts",
                    models.CharField(
                        blank=True,
                        max_length=256,
                        null=True,
                        verbose_name="Allowed accounts",
                    ),
                ),
                (
                    "aliases",
                    models.CharField(
                        blank=True, max_length=256, null=True, verbose_name="Aliases"
                    ),
                ),
                (
                    "variants",
                    models.TextField(blank=True, null=True, verbose_name="Variants"),
                ),
                (
                    "config",
                    pytigon_lib.schdjangoext.fields.ForeignKey(
                        blank=True,
                        limit_choices_to=schprofile.models.limit_config,
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="profile_configs",
                        to="schelements.element",
                        verbose_name="Config",
                    ),
                ),
                (
                    "owner",
                    pytigon_lib.schdjangoext.fields.ForeignKey(
                        blank=True,
                        limit_choices_to=schprofile.models.limit_owner,
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="profile_owners",
                        to="schelements.element",
                        verbose_name="Owner",
                    ),
                ),
                (
                    "user",
                    models.OneToOneField(
                        on_delete=django.db.models.deletion.CASCADE,
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
            options={
                "verbose_name": "Profile",
                "verbose_name_plural": "Profiles",
                "ordering": ["id"],
                "permissions": [("admin_profile", "Can administer profiles")],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
    ]
