# Generated by Django 5.1.3 on 2025-05-14 16:54

import django.db.models.deletion
import pytigon_lib.schdjangoext.fields
import pytigon_lib.schtools.schjson
from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="CommonGroupDef",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "app",
                    models.CharField(
                        db_index=True, max_length=16, verbose_name="Application"
                    ),
                ),
                (
                    "name",
                    models.CharField(db_index=True, max_length=64, verbose_name="Name"),
                ),
                (
                    "description",
                    models.CharField(max_length=64, verbose_name="Description"),
                ),
                (
                    "declaration",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Declaration",
                    ),
                ),
                (
                    "template_src",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Template source",
                    ),
                ),
                (
                    "template",
                    models.TextField(
                        blank=True, editable=False, null=True, verbose_name="Template"
                    ),
                ),
                (
                    "to_html_rec",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Convert fields to html",
                    ),
                ),
                (
                    "save_fun",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Save function",
                    ),
                ),
                (
                    "load_fun",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Load function",
                    ),
                ),
                (
                    "to_str_fun",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Object to str function",
                    ),
                ),
                (
                    "action_template",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Action template",
                    ),
                ),
                (
                    "info_template",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Info template",
                    ),
                ),
                (
                    "on_delete_fun",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Fnction called when deleting an object",
                    ),
                ),
                (
                    "action_fun",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Additional actions",
                    ),
                ),
                (
                    "on_new_elem_event",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="On new elemetn event",
                    ),
                ),
                (
                    "allowed_new_fields",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Allowed new fields",
                    ),
                ),
                (
                    "main_group",
                    models.BooleanField(
                        blank=True, null=True, verbose_name="Main group"
                    ),
                ),
            ],
            options={
                "verbose_name": "Common group definition",
                "verbose_name_plural": "Common groups definition",
                "ordering": ["id"],
                "permissions": [
                    ("admin_commongroupdef", "Can administer common group definitions")
                ],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
        migrations.CreateModel(
            name="CommonGroup",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "jsondata",
                    models.JSONField(
                        blank=True,
                        decoder=pytigon_lib.schtools.schjson.ComplexDecoder,
                        editable=False,
                        encoder=pytigon_lib.schtools.schjson.ComplexEncoder,
                        null=True,
                        verbose_name="Json data",
                    ),
                ),
                (
                    "title",
                    models.CharField(
                        blank=True, max_length=64, null=True, verbose_name="Title"
                    ),
                ),
                (
                    "group_def_name",
                    models.CharField(
                        max_length=64, verbose_name="Group definition name"
                    ),
                ),
                (
                    "gp_group_def_name",
                    models.CharField(
                        max_length=64, verbose_name="Grand parent group definition name"
                    ),
                ),
                (
                    "tag_name",
                    models.CharField(
                        blank=True, max_length=64, null=True, verbose_name="Tag name"
                    ),
                ),
                (
                    "key1",
                    models.CharField(
                        blank=True,
                        db_index=True,
                        max_length=64,
                        null=True,
                        verbose_name="Key 1",
                    ),
                ),
                (
                    "key2",
                    models.CharField(
                        blank=True,
                        db_index=True,
                        max_length=64,
                        null=True,
                        verbose_name="Key 2",
                    ),
                ),
                (
                    "key3",
                    models.CharField(
                        blank=True,
                        db_index=True,
                        max_length=64,
                        null=True,
                        verbose_name="Key 3",
                    ),
                ),
                (
                    "gparent",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="gparentrel",
                        to="schstruct.commongroup",
                        verbose_name="Grand parent",
                    ),
                ),
                (
                    "parent",
                    pytigon_lib.schdjangoext.fields.TreeForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        to="schstruct.commongroup",
                        verbose_name="Parent",
                    ),
                ),
            ],
            options={
                "verbose_name": "Common group",
                "verbose_name_plural": "Common groups",
                "ordering": ["id"],
                "permissions": [("admin_commongroup", "Can administer common groups")],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
    ]
