# Generated by Django 5.1.3 on 2025-05-14 16:54

import django.db.models.deletion
import pytigon_lib.schdjangoext.fields
import pytigon_lib.schtools.schjson
from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="ActionType",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "name",
                    models.CharField(db_index=True, max_length=64, verbose_name="Name"),
                ),
                (
                    "script_for_new_item",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Script for new task",
                    ),
                ),
                (
                    "script_for_close_item",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Script for close action",
                    ),
                ),
                (
                    "script_for_email_text",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Script for get email text",
                    ),
                ),
            ],
            options={
                "verbose_name": "Action type",
                "verbose_name_plural": "Action types",
                "ordering": ["id"],
                "permissions": [("admin_actiontype", "Can administer action types")],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
        migrations.CreateModel(
            name="Action",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "jsondata",
                    models.JSONField(
                        blank=True,
                        decoder=pytigon_lib.schtools.schjson.ComplexDecoder,
                        editable=False,
                        encoder=pytigon_lib.schtools.schjson.ComplexEncoder,
                        null=True,
                        verbose_name="Json data",
                    ),
                ),
                (
                    "application",
                    models.CharField(
                        db_index=True,
                        editable=False,
                        max_length=64,
                        verbose_name="Application",
                    ),
                ),
                (
                    "table",
                    models.CharField(
                        db_index=True,
                        default="default",
                        editable=False,
                        max_length=64,
                        verbose_name="Table",
                    ),
                ),
                (
                    "group",
                    models.CharField(
                        blank=True,
                        db_index=True,
                        default="default",
                        editable=False,
                        max_length=64,
                        null=True,
                        verbose_name="Group",
                    ),
                ),
                (
                    "parent_id",
                    models.IntegerField(
                        blank=True,
                        db_index=True,
                        editable=False,
                        null=True,
                        verbose_name="Parent id",
                    ),
                ),
                (
                    "description",
                    models.CharField(max_length=256, verbose_name="Description"),
                ),
                (
                    "start_date",
                    models.DateTimeField(auto_now_add=True, verbose_name="Start date"),
                ),
                (
                    "deadline",
                    models.DateTimeField(
                        blank=True, null=True, verbose_name="Deadline"
                    ),
                ),
                (
                    "email_action_owner",
                    models.EmailField(
                        blank=True,
                        db_index=True,
                        max_length=254,
                        null=True,
                        verbose_name="Email address of the action owner",
                    ),
                ),
                (
                    "email_action_done",
                    models.EmailField(
                        blank=True,
                        max_length=254,
                        null=True,
                        verbose_name="Email - action done",
                    ),
                ),
                (
                    "email_deadline_exceeded",
                    models.EmailField(
                        blank=True,
                        max_length=254,
                        null=True,
                        verbose_name="Email - deadline exceeded",
                    ),
                ),
                (
                    "info",
                    models.TextField(
                        blank=True, editable=False, null=True, verbose_name="Info"
                    ),
                ),
                (
                    "has_attachment",
                    models.BooleanField(
                        blank=True,
                        default=False,
                        null=True,
                        verbose_name="Has an attachment",
                    ),
                ),
                (
                    "has_workflow",
                    models.BooleanField(
                        blank=True,
                        default=False,
                        null=True,
                        verbose_name="Has a workflow",
                    ),
                ),
                (
                    "status",
                    models.CharField(
                        blank=True,
                        db_index=True,
                        max_length=16,
                        null=True,
                        verbose_name="None",
                    ),
                ),
                (
                    "parent_action",
                    pytigon_lib.schdjangoext.fields.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        to="schactions.action",
                        verbose_name="Parent action",
                    ),
                ),
                (
                    "action_type",
                    pytigon_lib.schdjangoext.fields.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="schactions.actiontype",
                        verbose_name="Action type",
                    ),
                ),
            ],
            options={
                "verbose_name": "Action",
                "verbose_name_plural": "Actions",
                "ordering": ["id"],
                "permissions": [("admin_action", "Can administer actions")],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
    ]
