# Generated by Django 5.1.3 on 2025-05-14 16:54

import django.db.models.deletion
import django.utils.timezone
import pytigon_lib.schdjangoext.fields
import pytigon_lib.schtools.schjson
import schattachements.models
from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ("schelements", "0001_initial"),
    ]

    operations = [
        migrations.CreateModel(
            name="Attachement",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "jsondata",
                    models.JSONField(
                        blank=True,
                        decoder=pytigon_lib.schtools.schjson.ComplexDecoder,
                        editable=False,
                        encoder=pytigon_lib.schtools.schjson.ComplexEncoder,
                        null=True,
                        verbose_name="Json data",
                    ),
                ),
                (
                    "application",
                    models.CharField(
                        db_index=True,
                        editable=False,
                        max_length=64,
                        verbose_name="Application",
                    ),
                ),
                (
                    "table",
                    models.CharField(
                        db_index=True,
                        default="default",
                        editable=False,
                        max_length=64,
                        verbose_name="Table",
                    ),
                ),
                (
                    "group",
                    models.CharField(
                        blank=True,
                        db_index=True,
                        default="default",
                        editable=False,
                        max_length=64,
                        null=True,
                        verbose_name="Group",
                    ),
                ),
                (
                    "parent_id",
                    models.IntegerField(
                        blank=True,
                        db_index=True,
                        editable=False,
                        null=True,
                        verbose_name="Parent id",
                    ),
                ),
                (
                    "name",
                    models.CharField(
                        blank=True, max_length=256, null=True, verbose_name="Name"
                    ),
                ),
                (
                    "ext",
                    models.CharField(
                        blank=True,
                        editable=False,
                        max_length=64,
                        null=True,
                        verbose_name="Extension",
                    ),
                ),
                (
                    "thumb",
                    models.TextField(
                        blank=True, editable=False, null=True, verbose_name="thumbnail"
                    ),
                ),
                (
                    "upload_date",
                    models.DateTimeField(
                        default=django.utils.timezone.now,
                        editable=False,
                        verbose_name="Upload date",
                    ),
                ),
                (
                    "modify_date",
                    models.DateTimeField(
                        blank=True,
                        default=django.utils.timezone.now,
                        editable=False,
                        null=True,
                        verbose_name="Modify date",
                    ),
                ),
                (
                    "file",
                    models.FileField(
                        upload_to=schattachements.models.upload_path_fun,
                        verbose_name="Select file",
                    ),
                ),
                (
                    "description",
                    models.CharField(
                        blank=True,
                        max_length=256,
                        null=True,
                        verbose_name="Description",
                    ),
                ),
                (
                    "status",
                    models.CharField(
                        blank=True, max_length=16, null=True, verbose_name="Status"
                    ),
                ),
                (
                    "folder",
                    pytigon_lib.schdjangoext.fields.ForeignKey(
                        blank=True,
                        limit_choices_to={"type__startswith": "C-FLD"},
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        to="schelements.element",
                        verbose_name="Folder",
                    ),
                ),
            ],
            options={
                "verbose_name": "Attachement",
                "verbose_name_plural": "Attachements",
                "ordering": ["id"],
                "permissions": [("admin_attachement", "Can administer attachments")],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
    ]
