# Generated by Django 5.1.3 on 2025-05-14 16:54

import django.db.models.deletion
import pytigon_lib.schdjangoext.fields
import pytigon_lib.schtools.schjson
from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="WorkflowType",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "name",
                    models.CharField(db_index=True, max_length=64, verbose_name="Name"),
                ),
                (
                    "script_for_new_item",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Script for new workflow item",
                    ),
                ),
                (
                    "script_for_accept_item",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Script for accept workflow item",
                    ),
                ),
                (
                    "script_for_reject_item",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Script for reject workflow item",
                    ),
                ),
                (
                    "script_for_refresh_queue",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Script for refresh workflow queue",
                    ),
                ),
                (
                    "script_for_handle_event",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Script for handle event",
                    ),
                ),
            ],
            options={
                "verbose_name": "Workflow type",
                "verbose_name_plural": "Workflow types",
                "ordering": ["id"],
                "permissions": [
                    ("admin_workflowtype", "Can administer workflow types")
                ],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
        migrations.CreateModel(
            name="WorkflowItem",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "jsondata",
                    models.JSONField(
                        blank=True,
                        decoder=pytigon_lib.schtools.schjson.ComplexDecoder,
                        editable=False,
                        encoder=pytigon_lib.schtools.schjson.ComplexEncoder,
                        null=True,
                        verbose_name="Json data",
                    ),
                ),
                (
                    "application",
                    models.CharField(
                        db_index=True,
                        editable=False,
                        max_length=64,
                        verbose_name="Application",
                    ),
                ),
                (
                    "table",
                    models.CharField(
                        db_index=True,
                        default="default",
                        editable=False,
                        max_length=64,
                        verbose_name="Table",
                    ),
                ),
                (
                    "group",
                    models.CharField(
                        blank=True,
                        db_index=True,
                        default="default",
                        editable=False,
                        max_length=64,
                        null=True,
                        verbose_name="Group",
                    ),
                ),
                (
                    "parent_id",
                    models.IntegerField(
                        blank=True,
                        db_index=True,
                        editable=False,
                        null=True,
                        verbose_name="Parent id",
                    ),
                ),
                (
                    "level",
                    models.IntegerField(
                        blank=True, default=0, null=True, verbose_name="Level"
                    ),
                ),
                (
                    "user_email",
                    models.EmailField(
                        blank=True,
                        db_index=True,
                        max_length=254,
                        null=True,
                        verbose_name="User s email",
                    ),
                ),
                (
                    "creation_date",
                    models.DateTimeField(auto_now=True, verbose_name="Creation date"),
                ),
                (
                    "acceptance_date",
                    models.DateTimeField(
                        blank=True, null=True, verbose_name="Acceptance date"
                    ),
                ),
                (
                    "title",
                    models.CharField(
                        blank=True,
                        db_index=True,
                        max_length=128,
                        null=True,
                        verbose_name="Title",
                    ),
                ),
                (
                    "item_type",
                    models.CharField(
                        blank=True, max_length=16, null=True, verbose_name="Item type"
                    ),
                ),
                (
                    "status",
                    models.CharField(
                        blank=True,
                        choices=[
                            ("0", "active"),
                            ("1", "accepted"),
                            ("2", "rejected"),
                            ("8", "next"),
                            ("9", "cancelled"),
                        ],
                        default="0",
                        max_length=1,
                        null=True,
                        verbose_name="Status",
                    ),
                ),
                (
                    "workflow_type",
                    pytigon_lib.schdjangoext.fields.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="schworkflow.workflowtype",
                        verbose_name="Workflow type",
                    ),
                ),
            ],
            options={
                "verbose_name": "Workflow item",
                "verbose_name_plural": "Workflow items",
                "ordering": ["id"],
                "permissions": [
                    ("admin_workflowitem", "Can administer workflow items")
                ],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
    ]
