# Generated by Django 5.1.3 on 2025-05-14 16:54

import pytigon_lib.schtools.schjson
from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="Page",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "jsondata",
                    models.JSONField(
                        blank=True,
                        decoder=pytigon_lib.schtools.schjson.ComplexDecoder,
                        editable=False,
                        encoder=pytigon_lib.schtools.schjson.ComplexEncoder,
                        null=True,
                        verbose_name="Json data",
                    ),
                ),
                (
                    "subject",
                    models.CharField(
                        db_index=True, max_length=64, verbose_name="Subject"
                    ),
                ),
                (
                    "name",
                    models.CharField(db_index=True, max_length=64, verbose_name="Name"),
                ),
                (
                    "description",
                    models.CharField(
                        blank=True,
                        max_length=256,
                        null=True,
                        verbose_name="Description",
                    ),
                ),
                (
                    "content_src",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Content source",
                    ),
                ),
                (
                    "content",
                    models.TextField(
                        blank=True, editable=False, null=True, verbose_name="Content"
                    ),
                ),
                (
                    "base_template",
                    models.CharField(
                        blank=True,
                        max_length=64,
                        null=True,
                        verbose_name="Base template",
                    ),
                ),
                (
                    "rights_group",
                    models.CharField(
                        blank=True,
                        max_length=64,
                        null=True,
                        verbose_name="Rights group",
                    ),
                ),
                (
                    "prj_name",
                    models.CharField(
                        blank=True,
                        max_length=64,
                        null=True,
                        verbose_name="Project name",
                    ),
                ),
                (
                    "menu",
                    models.CharField(
                        blank=True, max_length=64, null=True, verbose_name="Menu path"
                    ),
                ),
                (
                    "menu_position",
                    models.IntegerField(
                        blank=True, null=True, verbose_name="Menu position"
                    ),
                ),
                (
                    "menu_icon",
                    models.CharField(
                        blank=True,
                        max_length=256,
                        null=True,
                        verbose_name="Icon in menu",
                    ),
                ),
                (
                    "menu_icon_size",
                    models.CharField(
                        choices=[("0", "small"), ("1", "medium"), ("2", "large")],
                        default="1",
                        max_length=1,
                        verbose_name="Icon size",
                    ),
                ),
                (
                    "operator",
                    models.CharField(
                        blank=True,
                        editable=False,
                        max_length=64,
                        null=True,
                        verbose_name="Operator",
                    ),
                ),
                (
                    "update_time",
                    models.DateTimeField(auto_now=True, verbose_name="Update time"),
                ),
                (
                    "published",
                    models.BooleanField(
                        db_index=True,
                        default=False,
                        editable=False,
                        null=True,
                        verbose_name="Published",
                    ),
                ),
                (
                    "latest",
                    models.BooleanField(
                        default=True, editable=False, null=True, verbose_name="Latest"
                    ),
                ),
            ],
            options={
                "verbose_name": "Page",
                "verbose_name_plural": "Page",
                "ordering": ["id"],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
        migrations.CreateModel(
            name="WikiConf",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "jsondata",
                    models.JSONField(
                        blank=True,
                        decoder=pytigon_lib.schtools.schjson.ComplexDecoder,
                        editable=False,
                        encoder=pytigon_lib.schtools.schjson.ComplexEncoder,
                        null=True,
                        verbose_name="Json data",
                    ),
                ),
                (
                    "subject",
                    models.CharField(max_length=64, verbose_name="Wiki subject"),
                ),
                (
                    "group_of_rights_to_view",
                    models.CharField(
                        blank=True,
                        max_length=64,
                        null=True,
                        verbose_name="A group of rights to view wiki",
                    ),
                ),
                (
                    "group_of_rights_to_edit",
                    models.CharField(
                        blank=True,
                        max_length=64,
                        null=True,
                        verbose_name="A group of rights to edit wiki",
                    ),
                ),
                (
                    "backup_copies",
                    models.IntegerField(verbose_name="Number of backup copies"),
                ),
                (
                    "publish_fun",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Function called after publishing",
                    ),
                ),
                (
                    "scss",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Additional scss styles",
                    ),
                ),
                (
                    "css",
                    models.TextField(
                        blank=True, editable=False, null=True, verbose_name="Css styles"
                    ),
                ),
                (
                    "page_header",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Page header",
                    ),
                ),
                (
                    "page_footer",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Page footer",
                    ),
                ),
                (
                    "git_repository",
                    models.CharField(
                        blank=True,
                        max_length=256,
                        null=True,
                        verbose_name="Git repository",
                    ),
                ),
            ],
            options={
                "verbose_name": "Wiki config",
                "verbose_name_plural": "Wiki config",
                "ordering": ["id"],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
    ]
