# Generated by Django 5.1.3 on 2025-05-14 16:54

import django.db.models.deletion
import pytigon_lib.schdjangoext.fields
import pytigon_lib.schtools.schjson
import schbuilder.models
from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="SChApp",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "jsondata",
                    models.JSONField(
                        blank=True,
                        decoder=pytigon_lib.schtools.schjson.ComplexDecoder,
                        editable=False,
                        encoder=pytigon_lib.schtools.schjson.ComplexEncoder,
                        null=True,
                        verbose_name="Json data",
                    ),
                ),
                ("name", models.CharField(max_length=64, verbose_name="Name")),
                (
                    "title",
                    models.CharField(
                        blank=True, max_length=255, null=True, verbose_name="Title"
                    ),
                ),
                (
                    "module_name",
                    models.CharField(max_length=64, verbose_name="Module name"),
                ),
                (
                    "module_title",
                    models.CharField(
                        blank=True,
                        max_length=255,
                        null=True,
                        verbose_name="Module title",
                    ),
                ),
                ("perms", models.BooleanField(default=False, verbose_name="Perms")),
                (
                    "index",
                    models.CharField(
                        blank=True, max_length=255, null=True, verbose_name="Index"
                    ),
                ),
                (
                    "model_code",
                    models.TextField(
                        blank=True, editable=False, null=True, verbose_name="Model code"
                    ),
                ),
                (
                    "view_code",
                    models.TextField(
                        blank=True, editable=False, null=True, verbose_name="View code"
                    ),
                ),
                (
                    "urls_code",
                    models.TextField(
                        blank=True, editable=False, null=True, verbose_name="Urls code"
                    ),
                ),
                (
                    "tasks_code",
                    models.TextField(blank=True, null=True, verbose_name="Tasks code"),
                ),
                (
                    "consumer_code",
                    models.TextField(
                        blank=True, null=True, verbose_name="Consumer code"
                    ),
                ),
                (
                    "doc",
                    models.TextField(
                        blank=True, editable=False, null=True, verbose_name="Doc"
                    ),
                ),
                (
                    "user_param",
                    models.TextField(
                        blank=True, null=True, verbose_name="Urser parameter"
                    ),
                ),
                (
                    "icon",
                    models.CharField(
                        blank=True, max_length=256, null=True, verbose_name="Icon"
                    ),
                ),
                (
                    "icon_size",
                    models.CharField(
                        choices=[("0", "small"), ("1", "medium"), ("2", "large")],
                        default="1",
                        max_length=1,
                        verbose_name="Icon size",
                    ),
                ),
                (
                    "icon_code",
                    models.TextField(
                        blank=True, editable=False, null=True, verbose_name="Icon code"
                    ),
                ),
            ],
            options={
                "verbose_name": "SChApp",
                "verbose_name_plural": "SChApp",
                "ordering": ["id"],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
        migrations.CreateModel(
            name="SChProject",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "jsondata",
                    models.JSONField(
                        blank=True,
                        decoder=pytigon_lib.schtools.schjson.ComplexDecoder,
                        editable=False,
                        encoder=pytigon_lib.schtools.schjson.ComplexEncoder,
                        null=True,
                        verbose_name="Json data",
                    ),
                ),
                ("name", models.CharField(max_length=64, verbose_name="Name")),
                ("title", models.CharField(max_length=255, verbose_name="Title")),
                (
                    "version",
                    models.CharField(
                        blank=True,
                        default="latest",
                        max_length=16,
                        null=True,
                        verbose_name="Version",
                    ),
                ),
                (
                    "main_view",
                    models.BooleanField(
                        blank=True,
                        default=True,
                        null=True,
                        verbose_name="Show in main view",
                    ),
                ),
                (
                    "ext_apps",
                    models.CharField(
                        blank=True,
                        max_length=4096,
                        null=True,
                        verbose_name="Extern applications",
                    ),
                ),
                (
                    "plugins",
                    models.CharField(
                        blank=True, max_length=4096, null=True, verbose_name="Plugins"
                    ),
                ),
                (
                    "gui_type",
                    models.CharField(
                        choices=[
                            ("standard", "standard"),
                            ("modern", "modern"),
                            ("tree", "tree"),
                            ("tray", "tray"),
                            ("dialog", "dialog"),
                            ("one_form", "one_form"),
                        ],
                        max_length=32,
                        verbose_name="Gui type",
                    ),
                ),
                (
                    "gui_elements",
                    models.CharField(
                        blank=True,
                        choices=[
                            (
                                "toolbar(file(open,exit),clipboard)",
                                "toolbar(file(open,exit),clipboard)",
                            ),
                            (
                                "toolbar(file(open,save,save_as,exit),clipboard)",
                                "toolbar(file(open,save,save_as,exit),clipboard)",
                            ),
                            ("toolbar(browse)", "toolbar(browse)"),
                        ],
                        max_length=1024,
                        null=True,
                        verbose_name="Gui elements",
                    ),
                ),
                (
                    "login_required",
                    models.BooleanField(
                        blank=True,
                        default=False,
                        null=True,
                        verbose_name="Login required",
                    ),
                ),
                (
                    "public",
                    models.BooleanField(
                        blank=True, default=False, null=True, verbose_name="Public"
                    ),
                ),
                (
                    "main",
                    models.BooleanField(
                        blank=True,
                        default=False,
                        null=True,
                        verbose_name="Main project",
                    ),
                ),
                (
                    "start_page",
                    models.CharField(
                        blank=True, max_length=255, null=True, verbose_name="Start page"
                    ),
                ),
                (
                    "user_app_template",
                    models.TextField(
                        blank=True, editable=False, null=True, verbose_name="Patches"
                    ),
                ),
                (
                    "app_main",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Main application entrypoint",
                    ),
                ),
                (
                    "doc",
                    models.TextField(
                        blank=True, editable=False, null=True, verbose_name="Doc"
                    ),
                ),
                (
                    "desktop_gui_type",
                    models.CharField(
                        choices=[
                            ("auto", "auto"),
                            ("desktop_standard", "desktop_standard"),
                            ("desktop_modern", "desktop_modern"),
                            ("tablet_standard", "tablet_standard"),
                            ("tablet_modern", "tablet_modern"),
                            ("smartfon_standard", "smartfon_standard"),
                            ("smartfon_modern", "smartfon_modern"),
                        ],
                        default="auto",
                        max_length=32,
                        verbose_name="Gui type for pc web browser",
                    ),
                ),
                (
                    "smartfon_gui_type",
                    models.CharField(
                        choices=[
                            ("auto", "auto"),
                            ("desktop_standard", "desktop_standard"),
                            ("desktop_modern", "desktop_modern"),
                            ("tablet_standard", "tablet_standard"),
                            ("tablet_modern", "tablet_modern"),
                            ("smartfon_standard", "smartfon_standard"),
                            ("smartfon_modern", "smartfon_modern"),
                        ],
                        default="auto",
                        max_length=32,
                        verbose_name="Gui type for smartfon",
                    ),
                ),
                (
                    "tablet_gui_type",
                    models.CharField(
                        choices=[
                            ("auto", "auto"),
                            ("desktop_standard", "desktop_standard"),
                            ("desktop_modern", "desktop_modern"),
                            ("tablet_standard", "tablet_standard"),
                            ("tablet_modern", "tablet_modern"),
                            ("smartfon_standard", "smartfon_standard"),
                            ("smartfon_modern", "smartfon_modern"),
                        ],
                        default="auto",
                        max_length=32,
                        verbose_name="Gui type for tablet",
                    ),
                ),
                (
                    "additional_settings",
                    models.TextField(
                        blank=True, null=True, verbose_name="Additional settings"
                    ),
                ),
                (
                    "custom_tags",
                    models.TextField(blank=True, null=True, verbose_name="Custom tags"),
                ),
                (
                    "readme_file",
                    models.TextField(
                        blank=True, editable=False, null=True, verbose_name="README.md"
                    ),
                ),
                (
                    "license_file",
                    models.TextField(
                        blank=True, editable=False, null=True, verbose_name="LICENSE"
                    ),
                ),
                (
                    "install_file",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="install.ini",
                    ),
                ),
                (
                    "encoded_zip",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Encoded zip file",
                    ),
                ),
                (
                    "icon",
                    models.CharField(
                        blank=True, max_length=256, null=True, verbose_name="Icon"
                    ),
                ),
                (
                    "icon_size",
                    models.CharField(
                        choices=[("0", "small"), ("1", "medium"), ("2", "large")],
                        default="1",
                        max_length=1,
                        verbose_name="Icon size",
                    ),
                ),
                (
                    "icon_code",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Icon code (svg)",
                    ),
                ),
                (
                    "git_repository",
                    models.CharField(
                        blank=True,
                        max_length=255,
                        null=True,
                        verbose_name="Git repository",
                    ),
                ),
                (
                    "autor_name",
                    models.CharField(
                        blank=True, max_length=255, null=True, verbose_name="Autor name"
                    ),
                ),
                (
                    "autor_email",
                    models.CharField(
                        blank=True,
                        max_length=256,
                        null=True,
                        verbose_name="Autor email",
                    ),
                ),
                (
                    "autor_www",
                    models.CharField(
                        blank=True,
                        max_length=256,
                        null=True,
                        verbose_name="Autor www page",
                    ),
                ),
                (
                    "components_initial_state",
                    models.CharField(
                        blank=True,
                        max_length=1024,
                        null=True,
                        verbose_name="The initial state of the components",
                    ),
                ),
                (
                    "template_desktop",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Template for desktop",
                    ),
                ),
                (
                    "template_smartfon",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Template for smartfon",
                    ),
                ),
                (
                    "template_tablet",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Template for tablet",
                    ),
                ),
                (
                    "template_schweb",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Template for schweb (native app)",
                    ),
                ),
                (
                    "template_theme",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Base template",
                    ),
                ),
            ],
            options={
                "verbose_name": "Pytigon project",
                "verbose_name_plural": "Pytigon projects",
                "ordering": ["id"],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
        migrations.CreateModel(
            name="SChAppMenu",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=255, verbose_name="Name")),
                ("url", models.CharField(max_length=255, verbose_name="Url")),
                (
                    "url_type",
                    models.CharField(
                        blank=True,
                        choices=[
                            ("-", "default"),
                            ("desktop", "desktop only"),
                            ("panel", "desktop panel"),
                            ("header", "desktop header"),
                            ("footer", "desktop footer"),
                            ("script", "javascript"),
                            ("pscript", "python script"),
                            ("browser", "browser only"),
                            ("browser_panel", "prowser_panel"),
                            ("browser_header", "browser_header"),
                            ("browser_footer", "browser_footer"),
                        ],
                        default="-",
                        max_length=16,
                        null=True,
                        verbose_name="Url type",
                    ),
                ),
                (
                    "perms",
                    models.CharField(
                        blank=True, max_length=255, null=True, verbose_name="Perms"
                    ),
                ),
                (
                    "icon",
                    models.CharField(
                        blank=True, max_length=255, null=True, verbose_name="Icon"
                    ),
                ),
                (
                    "icon_size",
                    models.CharField(
                        choices=[("0", "small"), ("1", "medium"), ("2", "large")],
                        default="1",
                        max_length=1,
                        verbose_name="Icon size",
                    ),
                ),
                (
                    "icon_code",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Icon code (svg)",
                    ),
                ),
                (
                    "parent",
                    pytigon_lib.schdjangoext.fields.HiddenForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="schbuilder.schapp",
                        verbose_name="Parent",
                    ),
                ),
            ],
            options={
                "verbose_name": "SChAppMenu",
                "verbose_name_plural": "SChAppMenu",
                "ordering": ["id"],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
        migrations.CreateModel(
            name="SChChannelConsumer",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=255, verbose_name="Name")),
                (
                    "consumer_type",
                    models.CharField(
                        choices=[
                            ("WebsocketConsumer", "WebsocketConsumer"),
                            ("AsyncWebsocketConsumer", "AsyncWebsocketConsumer"),
                            ("JsonWebsocketConsumer", "JsonWebsocketConsumer"),
                            (
                                "AsyncJsonWebsocketConsumer",
                                "AsyncJsonWebsocketConsumer",
                            ),
                            ("AsyncHttpConsumer", "AsyncHttpConsumer"),
                            ("AsyncConsumer", "AsyncConsumer"),
                            ("SyncConsumer", "SyncConsumer"),
                        ],
                        max_length=64,
                        verbose_name="Consumer type",
                    ),
                ),
                (
                    "url",
                    models.CharField(
                        blank=True, max_length=255, null=True, verbose_name="Url"
                    ),
                ),
                (
                    "consumer_code",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Consumer code",
                    ),
                ),
                (
                    "doc",
                    models.TextField(
                        blank=True, editable=False, null=True, verbose_name="Doc"
                    ),
                ),
                (
                    "parent",
                    pytigon_lib.schdjangoext.fields.HiddenForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="schbuilder.schapp",
                        verbose_name="Parent",
                    ),
                ),
            ],
            options={
                "verbose_name": "Channel consumer",
                "verbose_name_plural": "Channel consumers",
                "ordering": ["id"],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
        migrations.CreateModel(
            name="SChChoice",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=255, verbose_name="Name")),
                (
                    "verbose_name",
                    models.CharField(max_length=255, verbose_name="Verbose name"),
                ),
                (
                    "parent",
                    pytigon_lib.schdjangoext.fields.HiddenForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="schbuilder.schapp",
                        verbose_name="Parent",
                    ),
                ),
            ],
            options={
                "verbose_name": "SChChoice",
                "verbose_name_plural": "SChChoice",
                "ordering": ["id"],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
        migrations.CreateModel(
            name="SChChoiceItem",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=255, verbose_name="Key name")),
                (
                    "value",
                    models.CharField(max_length=255, verbose_name="Verbose name"),
                ),
                (
                    "parent",
                    pytigon_lib.schdjangoext.fields.HiddenForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="schbuilder.schchoice",
                        verbose_name="Parent",
                    ),
                ),
            ],
            options={
                "verbose_name": "SChChoiceItem",
                "verbose_name_plural": "SChChoiceItem",
                "ordering": ["id"],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
        migrations.CreateModel(
            name="SChFile",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "type",
                    models.CharField(
                        choices=[
                            ("f", "TemplateFilters"),
                            ("t", "TemplateTags"),
                            ("c", "Custom file"),
                            ("m", "Management command"),
                            ("p", "Plugin code"),
                            ("i", "Plugin template"),
                            ("l", "Library code"),
                            ("s", "GraphQL schema"),
                            ("r", "Rest api"),
                            ("j", "Frontend view"),
                            ("T", "Frontend template"),
                            ("n", "Pytigon extension in nim"),
                            ("N", "Nim executable source file"),
                            ("E", "Nimpy extension"),
                            ("C", "css (included in desktop.html)"),
                            ("J", "javascript (included in desktop.html)"),
                            ("P", "python to javascript (included in desktop.html)"),
                            ("R", "component (included in desktop.html)"),
                            ("I", "sass to css (included in desktop.html)"),
                            (
                                "U",
                                "custom file (embeded translation for .pyj, .webc, .sass)",
                            ),
                            ("O", "Other application file"),
                            ("B", "Other application file (base64 encoded)"),
                        ],
                        max_length=3,
                        verbose_name="type",
                    ),
                ),
                ("name", models.CharField(max_length=256, verbose_name="Name")),
                (
                    "content",
                    models.TextField(
                        blank=True, editable=False, null=True, verbose_name="Content"
                    ),
                ),
                (
                    "doc",
                    models.TextField(
                        blank=True, editable=False, null=True, verbose_name="Doc"
                    ),
                ),
                (
                    "parent",
                    pytigon_lib.schdjangoext.fields.HiddenForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="schbuilder.schapp",
                        verbose_name="Parent",
                    ),
                ),
            ],
            options={
                "verbose_name": "SChFile",
                "verbose_name_plural": "SChFiles",
                "ordering": ["id"],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
        migrations.CreateModel(
            name="SChForm",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=64, verbose_name="Name")),
                (
                    "module",
                    models.CharField(
                        blank=True, max_length=64, null=True, verbose_name="Module"
                    ),
                ),
                (
                    "process_code",
                    models.TextField(
                        blank=True, null=True, verbose_name="Process code"
                    ),
                ),
                (
                    "end_class_code",
                    models.TextField(
                        blank=True, null=True, verbose_name="End class code"
                    ),
                ),
                (
                    "end_code",
                    models.TextField(blank=True, null=True, verbose_name="End code"),
                ),
                (
                    "asynchronous",
                    models.BooleanField(
                        blank=True, default=False, null=True, verbose_name="Async"
                    ),
                ),
                ("doc", models.TextField(blank=True, null=True, verbose_name="Doc")),
                (
                    "parent",
                    pytigon_lib.schdjangoext.fields.HiddenForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="schbuilder.schapp",
                        verbose_name="Parent",
                    ),
                ),
            ],
            options={
                "verbose_name": "Form",
                "verbose_name_plural": "Form",
                "ordering": ["id"],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
        migrations.CreateModel(
            name="SChFormField",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=64, verbose_name="Name")),
                (
                    "type",
                    models.CharField(
                        choices=[
                            ("BooleanField", "BooleanField"),
                            ("CharField", "CharField"),
                            ("ChoiceField", "ChoiceField"),
                            ("ComboField", "ComboField"),
                            ("DateField", "DateField"),
                            ("DateTimeField", "DateTimeField"),
                            ("DecimalField", "DecimalField"),
                            ("DurationField", "DurationField"),
                            ("EmailField", "EmailField"),
                            ("FileField", "FileField"),
                            ("FilePathField", "FilePathField"),
                            ("FloatField", "FloatField"),
                            ("GenericIPAddressField", "GenericIPAddressField"),
                            ("ImageField", "ImageField"),
                            ("IntegerField", "IntegerField"),
                            ("JSONField", "JSONField"),
                            ("MultiValueField", "MultiValueField"),
                            ("MultipleChoiceField", "MultipleChoiceField"),
                            ("NullBooleanField", "NullBooleanField"),
                            ("RegexField", "RegexField"),
                            ("SlugField", "SlugField"),
                            ("SplitDateTimeField", "SplitDateTimeField"),
                            ("TimeField", "TimeField"),
                            ("TypedChoiceField", "TypedChoiceField"),
                            ("TypedMultipleChoiceField", "TypedMultipleChoiceField"),
                            ("URLField", "URLField"),
                            ("UUIDField", "UUIDField"),
                            ("InlineForeignKeyField", "InlineForeignKeyField"),
                            ("ModelChoiceField", "ModelChoiceField"),
                            ("ModelMultipleChoiceField", "ModelMultipleChoiceField"),
                            ("HeavySelect2Field", "HeavySelect2Field"),
                            ("HeavySelect2MultipleField", "HeavySelect2MultipleField"),
                            ("ModelSelect2Field", "ModelSelect2Field"),
                            ("ModelSelect2MultipleField", "ModelSelect2MultipleField"),
                            ("Select2Field", "Select2Field"),
                            ("Select2MultipleField", "Select2MultipleField"),
                            ("UserField", "UserField"),
                        ],
                        max_length=64,
                        verbose_name="Type",
                    ),
                ),
                (
                    "required",
                    models.BooleanField(default=False, verbose_name="Required"),
                ),
                ("label", models.CharField(max_length=64, verbose_name="Label")),
                (
                    "initial",
                    models.CharField(
                        blank=True, max_length=256, null=True, verbose_name="Initial"
                    ),
                ),
                (
                    "widget",
                    models.CharField(
                        blank=True, max_length=256, null=True, verbose_name="Widget"
                    ),
                ),
                (
                    "help_text",
                    models.CharField(
                        blank=True, max_length=256, null=True, verbose_name="Help text"
                    ),
                ),
                (
                    "error_messages",
                    models.CharField(
                        blank=True,
                        max_length=64,
                        null=True,
                        verbose_name="Error messages",
                    ),
                ),
                (
                    "param",
                    models.CharField(
                        blank=True, max_length=1024, null=True, verbose_name="Param"
                    ),
                ),
                (
                    "parent",
                    pytigon_lib.schdjangoext.fields.HiddenForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="schbuilder.schform",
                        verbose_name="Parent",
                    ),
                ),
            ],
            options={
                "verbose_name": "Form field",
                "verbose_name_plural": "Form field",
                "ordering": ["id"],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
        migrations.CreateModel(
            name="SChLocale",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=16, verbose_name="Name")),
                (
                    "parent",
                    pytigon_lib.schdjangoext.fields.HiddenForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="schbuilder.schproject",
                        verbose_name="Parent",
                    ),
                ),
            ],
            options={
                "verbose_name": "Locale",
                "verbose_name_plural": "Locales",
                "ordering": ["id"],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
        migrations.AddField(
            model_name="schapp",
            name="parent",
            field=pytigon_lib.schdjangoext.fields.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                to="schbuilder.schproject",
                verbose_name="Parent",
            ),
        ),
        migrations.CreateModel(
            name="SChStatic",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "type",
                    models.CharField(
                        choices=[
                            ("C", "css (included in desktop.html)"),
                            ("J", "javascript (included in desktop.html)"),
                            ("P", "python to javascript (included in desktop.html)"),
                            ("R", "component (included in desktop.html)"),
                            ("I", "sass to css (included in desktop.html)"),
                            (
                                "U",
                                "custom file (embeded translation for .pyj, .webc, .sass)",
                            ),
                            ("O", "Other project file"),
                            ("B", "Other project file (base64 encoded)"),
                        ],
                        max_length=1,
                        verbose_name="Type",
                    ),
                ),
                ("name", models.CharField(max_length=64, verbose_name="Name")),
                (
                    "content",
                    models.TextField(
                        blank=True, editable=False, null=True, verbose_name="Content"
                    ),
                ),
                (
                    "doc",
                    models.TextField(
                        blank=True, editable=False, null=True, verbose_name="Doc"
                    ),
                ),
                (
                    "parent",
                    pytigon_lib.schdjangoext.fields.HiddenForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="schbuilder.schproject",
                        verbose_name="Parent",
                    ),
                ),
            ],
            options={
                "verbose_name": "Static file",
                "verbose_name_plural": "Static files",
                "ordering": ["id"],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
        migrations.CreateModel(
            name="SChTable",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "base_table",
                    models.CharField(
                        blank=True, max_length=255, null=True, verbose_name="Base table"
                    ),
                ),
                ("name", models.CharField(max_length=255, verbose_name="Name")),
                (
                    "verbose_name",
                    models.CharField(max_length=255, verbose_name="Verbose name"),
                ),
                (
                    "verbose_name_plural",
                    models.CharField(
                        max_length=255, verbose_name="Verbose name plural"
                    ),
                ),
                (
                    "metaclass_code",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Metaclass code",
                    ),
                ),
                (
                    "table_code",
                    models.TextField(
                        blank=True, editable=False, null=True, verbose_name="Table code"
                    ),
                ),
                (
                    "ordering",
                    models.CharField(
                        blank=True,
                        default="['id']",
                        max_length=255,
                        null=True,
                        verbose_name="Ordering",
                    ),
                ),
                (
                    "doc",
                    models.TextField(
                        blank=True, editable=False, null=True, verbose_name="Doc"
                    ),
                ),
                ("generic", models.BooleanField(default=False, verbose_name="Generic")),
                (
                    "url_params",
                    models.CharField(
                        blank=True, max_length=255, null=True, verbose_name="Url params"
                    ),
                ),
                (
                    "proxy_model",
                    models.CharField(
                        blank=True,
                        max_length=255,
                        null=True,
                        verbose_name="Proxy model",
                    ),
                ),
                (
                    "parent",
                    pytigon_lib.schdjangoext.fields.HiddenForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="schbuilder.schapp",
                        verbose_name="Parent",
                    ),
                ),
            ],
            options={
                "verbose_name": "SChTable",
                "verbose_name_plural": "SChTable",
                "ordering": ["id"],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
        migrations.CreateModel(
            name="SChField",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "name",
                    models.CharField(
                        blank=True, max_length=255, null=True, verbose_name="Name"
                    ),
                ),
                (
                    "description",
                    models.CharField(
                        blank=True,
                        max_length=255,
                        null=True,
                        verbose_name="Description",
                    ),
                ),
                (
                    "type",
                    models.CharField(
                        choices=schbuilder.models.get_field_choices,
                        max_length=64,
                        verbose_name="Type",
                    ),
                ),
                ("null", models.BooleanField(default=False, verbose_name="Null")),
                ("blank", models.BooleanField(default=False, verbose_name="Blank")),
                (
                    "editable",
                    models.BooleanField(default=False, verbose_name="Editable"),
                ),
                ("unique", models.BooleanField(default=False, verbose_name="Unique")),
                (
                    "db_index",
                    models.BooleanField(default=False, verbose_name="DB index"),
                ),
                (
                    "default",
                    models.CharField(
                        blank=True, max_length=255, null=True, verbose_name="Default"
                    ),
                ),
                (
                    "help_text",
                    models.CharField(
                        blank=True, max_length=255, null=True, verbose_name="Help text"
                    ),
                ),
                (
                    "choices",
                    models.CharField(
                        blank=True, max_length=255, null=True, verbose_name="Choices"
                    ),
                ),
                (
                    "rel_to",
                    models.CharField(
                        blank=True,
                        max_length=255,
                        null=True,
                        verbose_name="Relation to",
                    ),
                ),
                (
                    "param",
                    models.CharField(
                        blank=True, max_length=255, null=True, verbose_name="Param"
                    ),
                ),
                (
                    "url_params",
                    models.CharField(
                        blank=True, max_length=255, null=True, verbose_name="Url params"
                    ),
                ),
                (
                    "parent",
                    pytigon_lib.schdjangoext.fields.HiddenForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="schbuilder.schtable",
                        verbose_name="Parent",
                    ),
                ),
            ],
            options={
                "verbose_name": "SChField",
                "verbose_name_plural": "SChField",
                "ordering": ["id"],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
        migrations.CreateModel(
            name="SChTask",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=255, verbose_name="Name")),
                (
                    "code",
                    models.TextField(
                        blank=True, editable=False, null=True, verbose_name="Code"
                    ),
                ),
                (
                    "doc",
                    models.TextField(
                        blank=True, editable=False, null=True, verbose_name="Doc"
                    ),
                ),
                (
                    "perms",
                    models.CharField(
                        blank=True, max_length=255, null=True, verbose_name="Perms"
                    ),
                ),
                (
                    "publish",
                    models.BooleanField(blank=True, null=True, verbose_name="Publish"),
                ),
                (
                    "publish_group",
                    models.CharField(
                        blank=True,
                        max_length=64,
                        null=True,
                        verbose_name="Publish group",
                    ),
                ),
                (
                    "parent",
                    pytigon_lib.schdjangoext.fields.HiddenForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="schbuilder.schapp",
                        verbose_name="Parent",
                    ),
                ),
            ],
            options={
                "verbose_name": "SChTask",
                "verbose_name_plural": "SChTask",
                "ordering": ["id"],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
        migrations.CreateModel(
            name="SChTemplate",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=255, verbose_name="Name")),
                (
                    "direct_to_template",
                    models.BooleanField(
                        blank=True, null=True, verbose_name="Direct to template"
                    ),
                ),
                (
                    "url",
                    models.CharField(
                        blank=True, max_length=64, null=True, verbose_name="Url"
                    ),
                ),
                (
                    "url_parm",
                    models.CharField(
                        blank=True,
                        max_length=128,
                        null=True,
                        verbose_name="Parameters passed to the template",
                    ),
                ),
                (
                    "template_code",
                    models.TextField(
                        blank=True,
                        editable=False,
                        null=True,
                        verbose_name="Template code",
                    ),
                ),
                (
                    "tags_mount",
                    models.CharField(
                        blank=True,
                        max_length=256,
                        null=True,
                        verbose_name="Mount component tags",
                    ),
                ),
                (
                    "asynchronous",
                    models.BooleanField(
                        blank=True, default=False, null=True, verbose_name="Async"
                    ),
                ),
                (
                    "parent",
                    pytigon_lib.schdjangoext.fields.HiddenForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="schbuilder.schapp",
                        verbose_name="Parent",
                    ),
                ),
                (
                    "static_files",
                    models.ManyToManyField(
                        blank=True,
                        null=True,
                        to="schbuilder.schstatic",
                        verbose_name="Static files",
                    ),
                ),
            ],
            options={
                "verbose_name": "SChTemplate",
                "verbose_name_plural": "SChTemplate",
                "ordering": ["id"],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
        migrations.CreateModel(
            name="SChTranslate",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "description",
                    models.CharField(max_length=1024, verbose_name="Description"),
                ),
                (
                    "translation",
                    models.CharField(
                        blank=True,
                        max_length=1024,
                        null=True,
                        verbose_name="Translation",
                    ),
                ),
                (
                    "status",
                    models.CharField(
                        blank=True,
                        editable=False,
                        max_length=16,
                        null=True,
                        verbose_name="Status",
                    ),
                ),
                (
                    "parent",
                    pytigon_lib.schdjangoext.fields.HiddenForeignKey(
                        editable=False,
                        on_delete=django.db.models.deletion.CASCADE,
                        to="schbuilder.schlocale",
                        verbose_name="Parent",
                    ),
                ),
            ],
            options={
                "verbose_name": "Translate",
                "verbose_name_plural": "Translate",
                "ordering": ["id"],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
        migrations.CreateModel(
            name="SChView",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=255, verbose_name="Name")),
                (
                    "view_type",
                    models.CharField(
                        choices=[
                            ("t", "Table action"),
                            ("r", "Row action"),
                            ("u", "View"),
                        ],
                        max_length=1,
                        verbose_name="View type",
                    ),
                ),
                (
                    "param",
                    models.CharField(
                        blank=True, max_length=255, null=True, verbose_name="Param"
                    ),
                ),
                (
                    "url",
                    models.CharField(
                        blank=True, max_length=255, null=True, verbose_name="Url"
                    ),
                ),
                (
                    "view_code",
                    models.TextField(
                        blank=True, editable=False, null=True, verbose_name="View code"
                    ),
                ),
                (
                    "url_params",
                    models.CharField(
                        blank=True, max_length=255, null=True, verbose_name="Url params"
                    ),
                ),
                (
                    "ret_type",
                    models.CharField(
                        choices=[
                            ("T", "Template"),
                            ("O", "Odf format (default .ods)"),
                            ("P", "Pdf"),
                            ("J", "Json"),
                            ("X", "Xml"),
                            ("U", "User defined"),
                            ("S", "OOXML (default .xlsx)"),
                            ("t", "Txt"),
                            ("H", "Html to docx template (.hdoc)"),
                        ],
                        default="U",
                        max_length=1,
                        verbose_name="Return value type",
                    ),
                ),
                (
                    "asynchronous",
                    models.BooleanField(
                        blank=True, default=False, null=True, verbose_name="Async"
                    ),
                ),
                (
                    "extra_code",
                    models.TextField(
                        blank=True, editable=False, null=True, verbose_name="Extra code"
                    ),
                ),
                (
                    "doc",
                    models.TextField(
                        blank=True, editable=False, null=True, verbose_name="Doc"
                    ),
                ),
                (
                    "parent",
                    pytigon_lib.schdjangoext.fields.HiddenForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="schbuilder.schapp",
                        verbose_name="Parent",
                    ),
                ),
            ],
            options={
                "verbose_name": "SChView",
                "verbose_name_plural": "SChView",
                "ordering": ["id"],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
    ]
