# Generated by Django 5.1.3 on 2025-05-14 16:54

import django.db.models.deletion
import pytigon_lib.schdjangoext.fields
from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ("tables_demo", "0001_initial"),
    ]

    operations = [
        migrations.CreateModel(
            name="Album",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "release_date",
                    models.DateField(
                        blank=True, null=True, verbose_name="Release date"
                    ),
                ),
                (
                    "artist",
                    models.CharField(
                        blank=True, max_length=64, null=True, verbose_name="Artist"
                    ),
                ),
                (
                    "description",
                    models.CharField(max_length=256, verbose_name="Description"),
                ),
                (
                    "genre",
                    models.CharField(
                        choices=[
                            ("r", "Rock"),
                            ("p", "Pop"),
                            ("j", "Jazz"),
                            ("h", "Heavy Metal"),
                            ("e", "Elekctonic"),
                            ("c", "Classical"),
                            ("o", "Other"),
                        ],
                        max_length=2,
                        verbose_name="Genre",
                    ),
                ),
            ],
            options={
                "verbose_name": "Album",
                "verbose_name_plural": "Albums",
                "ordering": ["id"],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
        migrations.CreateModel(
            name="UserGroup",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
            ],
            options={
                "verbose_name": "User group",
                "verbose_name_plural": "User groups",
                "ordering": ["id"],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
        migrations.CreateModel(
            name="AlbumProxy",
            fields=[],
            options={
                "verbose_name": "Album",
                "verbose_name_plural": "Albums",
                "ordering": ["id"],
                "proxy": True,
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
                "indexes": [],
                "constraints": [],
            },
            bases=("tables_adv_demo.album",),
        ),
        migrations.CreateModel(
            name="Track",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=64, verbose_name="Name")),
                (
                    "param",
                    pytigon_lib.schdjangoext.fields.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        to="tables_demo.example4parameter",
                        verbose_name="Param",
                    ),
                ),
                (
                    "params",
                    pytigon_lib.schdjangoext.fields.ManyToManyField(
                        related_name="track_parameters",
                        to="tables_demo.example4parameter",
                        verbose_name="Parameters",
                    ),
                ),
                (
                    "parent",
                    pytigon_lib.schdjangoext.fields.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="tables_adv_demo.album",
                        verbose_name="Parent",
                    ),
                ),
            ],
            options={
                "verbose_name": "Track",
                "verbose_name_plural": "Tracks",
                "ordering": ["id"],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
    ]
