# Generated by Django 5.1.3 on 2025-05-14 16:54

import django.db.models.deletion
import pytigon_lib.schdjangoext.fields
import pytigon_lib.schtools.schjson
from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="Example1Computer",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("sn", models.CharField(max_length=64, verbose_name="Serial number")),
                (
                    "description",
                    models.CharField(max_length=64, verbose_name="Description"),
                ),
                (
                    "ip",
                    models.GenericIPAddressField(
                        blank=True, null=True, verbose_name="IP"
                    ),
                ),
                ("active", models.BooleanField(default=False, verbose_name="Active")),
            ],
            options={
                "verbose_name": "Computer",
                "verbose_name_plural": "Computers",
                "ordering": ["id"],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
        migrations.CreateModel(
            name="Example1User",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("username", models.CharField(max_length=64, verbose_name="User name")),
                (
                    "email",
                    models.EmailField(
                        blank=True, max_length=254, null=True, verbose_name="Email"
                    ),
                ),
            ],
            options={
                "verbose_name": "User",
                "verbose_name_plural": "Users",
                "ordering": ["id"],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
        migrations.CreateModel(
            name="Example3Tag",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "tag",
                    models.CharField(
                        choices=[("0", "Standard"), ("1", "Important")],
                        max_length=64,
                        verbose_name="Tag",
                    ),
                ),
                (
                    "description",
                    models.CharField(
                        blank=True, max_length=64, null=True, verbose_name="Description"
                    ),
                ),
                ("app", models.CharField(max_length=64, verbose_name="Application")),
                (
                    "table",
                    models.CharField(
                        blank=True, max_length=64, null=True, verbose_name="Table"
                    ),
                ),
                (
                    "parent_id",
                    models.IntegerField(
                        blank=True, null=True, verbose_name="Parent id"
                    ),
                ),
            ],
            options={
                "verbose_name": "Tag",
                "verbose_name_plural": "Tags",
                "ordering": ["id"],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
        migrations.CreateModel(
            name="Example4Parameter",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "jsondata",
                    models.JSONField(
                        blank=True,
                        decoder=pytigon_lib.schtools.schjson.ComplexDecoder,
                        editable=False,
                        encoder=pytigon_lib.schtools.schjson.ComplexEncoder,
                        null=True,
                        verbose_name="Json data",
                    ),
                ),
                ("key", models.CharField(max_length=32, verbose_name="Key")),
            ],
            options={
                "verbose_name": "Parameter",
                "verbose_name_plural": "Parameters",
                "ordering": ["id"],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
        migrations.CreateModel(
            name="Example6ComputerFromExample1",
            fields=[],
            options={
                "verbose_name": "Proxy to computer",
                "verbose_name_plural": "Proxy to computers",
                "ordering": ["id"],
                "proxy": True,
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
                "indexes": [],
                "constraints": [],
            },
            bases=("tables_demo.example1computer",),
        ),
        migrations.CreateModel(
            name="Example7ComputerFromExample1",
            fields=[],
            options={
                "verbose_name": "Proxy to computer",
                "verbose_name_plural": "Proxy to computers",
                "ordering": ["id"],
                "proxy": True,
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
                "indexes": [],
                "constraints": [],
            },
            bases=("tables_demo.example1computer",),
        ),
        migrations.CreateModel(
            name="Example2Peripheral",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "description",
                    models.CharField(max_length=64, verbose_name="Description"),
                ),
                (
                    "parent",
                    pytigon_lib.schdjangoext.fields.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="tables_demo.example1computer",
                        verbose_name="Parent",
                    ),
                ),
            ],
            options={
                "verbose_name": "Peripheral",
                "verbose_name_plural": "Peripherals",
                "ordering": ["id"],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
        migrations.CreateModel(
            name="Example5ParamGroup",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "jsondata",
                    models.JSONField(
                        blank=True,
                        decoder=pytigon_lib.schtools.schjson.ComplexDecoder,
                        editable=False,
                        encoder=pytigon_lib.schtools.schjson.ComplexEncoder,
                        null=True,
                        verbose_name="Json data",
                    ),
                ),
                (
                    "main_parameter",
                    pytigon_lib.schdjangoext.fields.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="tables_demo.example4parameter",
                        verbose_name="Main parameter",
                    ),
                ),
                (
                    "parameters",
                    pytigon_lib.schdjangoext.fields.ManyToManyField(
                        related_name="group_parameters",
                        to="tables_demo.example4parameter",
                        verbose_name="Parameters",
                    ),
                ),
                (
                    "parent",
                    pytigon_lib.schdjangoext.fields.TreeForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        to="tables_demo.example5paramgroup",
                        verbose_name="Parent",
                    ),
                ),
                (
                    "second_parameter",
                    pytigon_lib.schdjangoext.fields.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="second_parameters",
                        to="tables_demo.example4parameter",
                        verbose_name="Second parameter",
                    ),
                ),
            ],
            options={
                "verbose_name": "Group of parameters",
                "verbose_name_plural": "Groups of parameters",
                "ordering": ["id"],
                "default_permissions": (
                    "add",
                    "change",
                    "delete",
                    "view",
                    "list",
                    "administer",
                ),
            },
        ),
    ]
